## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.5

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# ElemTemplateElement Class Reference

`#include <ElemTemplateElement.hpp>`

Inheritance diagram for ElemTemplateElement:

[legend]
Collaboration diagram for ElemTemplateElement:

[legend]
List of all members.

## Public Types

- typedef XalanElement::NodeType NodeType

## Public Methods

- ElemTemplateElement (StylesheetConstructionContext &constructionContext, Stylesheet &stylesheetTree, int lineNumber, int columnNumber, int xslToken)
    Construct a template element instance. More...
- ElemTemplateElement (Stylesheet &stylesheetTree, int xslToken, int lineNumber=XalanLocator::getUnknownValue(), int columnNumber=XalanLocator::getUnknownValue())
    Special constructor used by dummy elements which do not exist in the final stylesheet. More...
- virtual ~ElemTemplateElement ()
- virtual const LocatorType* getLocator () const
    Get the Locator for the node. More...
- virtual bool isAttrOK (const XalanDOMChar *attrName, const AttributeListType &atts, int which, StylesheetConstructionContext &constructionContext) const
    See if this is a xmlns attribute or in a non-XSLT. More...
- bool processSpaceAttr (const XalanDOMChar *aname, const AttributeListType &atts, int which, StylesheetConstructionContext &constructionContext)
    Tell whether or not this is a xml:space attribute and, if so, process it. More...
- virtual void execute (StylesheetExecutionContext &executionContext) const
    Execute the element's primary function. More...
- virtual void executeChildren (StylesheetExecutionContext &executionContext) const
    Process the children of a template. More...
- virtual void executeChildren (StylesheetExecutionContext &executionContext, XalanNode *sourceNode) const
    Set the current node and process the children of a template. More...
- const XalanDOMString& childrenToString (StylesheetExecutionContext &executionContext, XalanDOMString &result) const
    Take the contents of a template element, process it, and convert it to a string. More...
- void childrenToResultAttribute (StylesheetExecutionContext &executionContext, const XalanDOMString &theName) const
    Take the contents of a template element, process it, and convert it to a string. More...
- void childrenToResultComment (StylesheetExecutionContext &executionContext) const
    Take the contents of a template element, process it, and convert it to a string. More...
- void childrenToResultPI (StylesheetExecutionContext &executionContext, const XalanDOMString &theTarget) const
    Take the contents of a template element, process it, and convert it to a string. More...
- int getXSLToken () const
    Get an integer representation of the element type. More...
- int getLineNumber () const
    Get the line number in the stylesheet where the element appears. More...
- int getColumnNumber () const
    Get the column number in the stylesheet where the element appears. More...
- virtual bool isWhitespace () const
    Tell if the element will generate text which is XML whitespace. More...
- virtual const XalanDOMString& getElementName () const=0
    Get a string for the name of the element. More...
- virtual const XalanQName& getNameAttribute () const
    Get the QName associated with any name attribute of this element. More...
- virtual void addToStylesheet (StylesheetConstructionContext &constructionContext, Stylesheet &theStylesheet)
    Called during compilation when an instance is not parented by another element, and thus, is a child of the stylesheet.. More...
- virtual void processSortElement (StylesheetConstructionContext &constructionContext, Stylesheet &theStylesheet, const AttributeListType &atts, const LocatorType *locator=0)
    Called during compilation to process xsl:sort elements in the stylesheet. More...
- virtual void setDefaultTemplate (bool value)
    Sets a flag indicating this is the default template. More...
- const NamespacesHandler& getNamespacesHandler () const
    Get the namespaces handler for this element. More...
- const Stylesheet& getStylesheet () const
    Retrieve the stylesheet from which this element comes. More...
- void setFinishedConstruction (bool fValue)
    Set the flag indicating construction of the element is completed. More...
- bool getFinishedConstruction () const
    Get the flag indicating construction of the element is completed. More...
- virtual void postConstruction (StylesheetConstructionContext &constructionContext, const NamespacesHandler &theParentHandler)
    Called after construction is completed. More...
- virtual ElemTemplateElement* getFirstChildElem () const
    Get the first child. More...
- virtual void setFirstChildElem (ElemTemplateElement *theChild)
    Set the first child. More...
- virtual ElemTemplateElement* getLastChildElem () const
    Get the last child. More...
- virtual ElemTemplateElement* getNextSiblingElem () const
    Get the next sibling. More...
- virtual void setNextSiblingElem (ElemTemplateElement *theSibling)
    Set the next sibling. More...
- virtual ElemTemplateElement* getPreviousSiblingElem () const
    Get the previous sibling. More...
- virtual void setPreviousSiblingElem (ElemTemplateElement *theSibling)
    Set the previous sibling. More...
- virtual ElemTemplateElement* getParentNodeElem () const
    Get the parent node. More...
- virtual void setParentNodeElem (ElemTemplateElement *theParent)
    Set the parent node. More...
- virtual ElemTemplateElement* appendChildElem (ElemTemplateElement *newChild)
    Append a child. More...
- virtual const XalanDOMString& getNodeName () const
- virtual const XalanDOMString& getNodeValue () const
    Gets the value of this node, depending on its type. More...
- virtual NodeType getNodeType () const
    An enum value representing the type of the underlying object. More...
- virtual XalanNode* getParentNode () const
    Gets the parent of this node. More...
- virtual const XalanNodeList* getChildNodes () const
    Gets a `NodeList` that contains all children of this node. More...
- virtual XalanNode* getFirstChild () const
    Gets the first child of this node. More...
- virtual XalanNode* getLastChild () const
    Gets the last child of this node. More...
- virtual XalanNode* getPreviousSibling () const
    Gets the node immediately preceding this node. More...
- virtual XalanNode* getNextSibling () const
    Gets the node immediately following this node. More...
- virtual const XalanNamedNodeMap* getAttributes () const
    Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. More...
- virtual XalanDocument* getOwnerDocument () const
    Gets the `Document` object associated with this node. More...
- virtual ElemTemplateElement* cloneNode (bool deep) const
    Returns a duplicate of this node. More...
- virtual XalanNode* insertBefore (XalanNode *newChild, XalanNode *refChild)
    Inserts the node `newChild` before the existing child node `refChild`. More...
- virtual XalanNode* replaceChild (XalanNode *newChild, XalanNode *oldChild)
    Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. More...
- virtual XalanNode* removeChild (XalanNode *oldChild)
    Removes the child node indicated by `oldChild` from the list of children, and returns it. More...
- virtual XalanNode* appendChild (XalanNode *newChild)
    Add a child to the child list. More...
- virtual bool hasChildNodes () const
    This is a convenience method to allow easy determination of whether a node has any children. More...
- virtual void setNodeValue (const XalanDOMString &nodeValue)
    Sets the value of the node. More...
- virtual void normalize ()
    Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. More...
- virtual bool isSupported (const XalanDOMString &feature, const XalanDOMString &version) const
    Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. More...
- virtual const XalanDOMString& getNamespaceURI () const
    Get the namespace URI of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getPrefix () const
    Get the namespace prefix of this node, or `null` if it is unspecified. More...
- virtual const XalanDOMString& getLocalName () const
    Returns the local part of the qualified name of this node. More...
- virtual void setPrefix (const XalanDOMString &prefix)
    Set the namespace prefix of this node. More...
- virtual bool isIndexed () const
    Determine if the document is node-order indexed. More...
- virtual IndexType getIndex () const
    Get the node's index. More...
- virtual const XalanDOMString& getTagName () const
    The name of the element. More...
- virtual const XalanDOMString& getAttribute (const XalanDOMString &name) const
    Retrieves an attribute value by name. More...
- virtual XalanAttr* getAttributeNode (const XalanDOMString &name) const
    Retrieves an `Attr` node by name. More...
- virtual XalanNodeList* getElementsByTagName (const XalanDOMString &name) const
    Returns a `NodeList` of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the `Element` tree. More...
- virtual void setAttribute (const XalanDOMString &name, const XalanDOMString &value)
    Adds a new attribute. More...
- virtual XalanAttr* setAttributeNode (XalanAttr *newAttr)
    Adds a new attribute. More...
- virtual XalanAttr* removeAttributeNode (XalanAttr *oldAttr)
    Removes the specified attribute node. More...
- virtual void removeAttribute (const XalanDOMString &name)
    Removes an attribute by name. More...
- virtual const XalanDOMString& getAttributeNS (const XalanDOMString &namespaceURI, const XalanDOMString &localName) const
    Retrieves an attribute value by local name and namespace URI. More...
- virtual void setAttributeNS (const XalanDOMString &namespaceURI, const XalanDOMString &qualifiedName, const XalanDOMString &value)
    Adds a new attribute. More...
- virtual void removeAttributeNS (const XalanDOMString &namespaceURI, const XalanDOMString &localName)
    Removes an attribute by local name and namespace URI. More...
- virtual XalanAttr* getAttributeNodeNS (const XalanDOMString &namespaceURI, const XalanDOMString &localName) const
    Retrieves an `Attr` node by local name and namespace URI. More...
- virtual XalanAttr* setAttributeNodeNS (XalanAttr *newAttr)
    Adds a new attribute. More...
- virtual XalanNodeList* getElementsByTagNameNS (const XalanDOMString &namespaceURI, const XalanDOMString &localName) const
    Returns a `NodeList` of all the `Element`s with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the `Document` tree, starting from this node. More...
- virtual const XalanDOMString* getNamespaceForPrefix (const XalanDOMString &prefix) const
    Retrieve a namespace corresponding to a prefix. More...
- virtual const XalanDOMString& getURI () const
    Retrieve the base URI for the resolver. More...
- bool hasParams () const
- bool hasVariables () const
- bool hasSingleTextChild () const
- bool hasChildren () const
- bool hasDirectTemplate () const
- bool canGenerateAttributes () const
- bool isDefaultTemplate () const

## Static Public Methods

- bool isValidNCName (const XalanDOMString &s)
    Validate that the string is an NCName. More...

## Protected Methods

- void canGenerateAttributes (bool value)
- void hasPrefix (bool value)
- bool hasPrefix () const
- void preserveSpace (bool value)
- bool preserveSpace () const
- void disableOutputEscaping (bool value)
- bool disableOutputEscaping () const
- bool processPrefixControl (StylesheetConstructionContext &constructionContext, const Stylesheet &stylesheetTree, const XalanDOMString &localName, const XalanDOMChar *attrValue)
    Process the exclude-result-prefixes or the extension-element-prefixes attributes, for the purpose of prefix exclusion. More...
- const XalanDOMString* getNamespaceForPrefixInternal (const XalanDOMString &prefix) const
    Get the namespace for a given prefix. More...
- virtual void transformChild (StylesheetExecutionContext &executionContext, const ElemTemplateElement &xslInstruction, const ElemTemplateElement *theTemplate, XalanNode *child) const
    Given an element, find the corresponding template and process the contents. More...
- virtual void transformChild (StylesheetExecutionContext &executionContext, const ElemTemplateElement &xslInstruction, const ElemTemplateElement *theTemplate, XalanNode *child, XalanNode::NodeType nodeType) const
    Given an element, find the corresponding template and process the contents. More...
- virtual bool childTypeAllowed (int xslToken) const
    Given an xsl token type, determine whether or not a child of that type is allowed. More...
- virtual void namespacesPostConstruction (StylesheetConstructionContext &constructionContext, const NamespacesHandler &theParentHandler, NamespacesHandler &theHandler)
    Called after construction is completed. More...
- const NamespacesHandler& getNamespaces () const

## Static Protected Attributes

- const XalanDOMString s_emptyString

## Member Typedef Documentation

typedef XalanElement::NodeType ElemTemplateElement::NodeType

| Reimplemented from XalanNode.

## Constructor & Destructor Documentation

ElemTemplateElement::ElemTemplateElement ( | StylesheetConstructionContext & constructionContext,
| Stylesheet & stylesheetTree,
| int lineNumber,
| int columnNumber,
| int xslToken )

  | Construct a template element instance. Parameters:
  constructionContext | context when object constructed
  stylesheetTree | owning stylesheet
  lineNumber | line in the XSLT file where the element occurs
  columnNumber | column index in the XSLT file where the element occurs
  xslToken | an integer representing the type of instance.

ElemTemplateElement::ElemTemplateElement ( | Stylesheet & stylesheetTree,
| int xslToken,
| int lineNumber = XalanLocator::getUnknownValue(),
| int columnNumber = XalanLocator::getUnknownValue() )

  | Special constructor used by dummy elements which do not exist in the final stylesheet. Parameters:
  stylesheetTree | owning stylesheet
  lineNumber | line in the XSLT file where the element occurs
  columnNumber | column index in the XSLT file where the element occurs
  xslToken | an integer representing the type of instance.

ElemTemplateElement::~ElemTemplateElement ( | )`[virtual]`

## Member Function Documentation

void ElemTemplateElement::addToStylesheet ( | StylesheetConstructionContext & constructionContext,
| Stylesheet & theStylesheet )`[virtual]`

  | Called during compilation when an instance is not parented by another element, and thus, is a child of the stylesheet.. Parameters:
  constructionContext | The current construction context
  theStylesheet | The owning stylesheet
Returns: nothing Reimplemented in ElemTemplate, and ElemVariable.

XalanNode * ElemTemplateElement::appendChild ( | XalanNode * newChild )`[virtual]`

  | Add a child to the child list. Exceptions:
  DOMException |
  Parameters:
  newChild | child node to add
Reimplemented from XalanElement.

ElemTemplateElement * ElemTemplateElement::appendChildElem ( | ElemTemplateElement * newChild )`[virtual]`

| Append a child. theParent - the new value for the parent. Returns: nothing Reimplemented in ElemApplyImport.

void ElemTemplateElement::canGenerateAttributes ( | bool value )`[protected]`

bool ElemTemplateElement::canGenerateAttributes ( | ) const

bool ElemTemplateElement::childTypeAllowed ( | int xslToken ) const`[protected, virtual]`

  | Given an xsl token type, determine whether or not a child of that type is allowed. This is so derived types can determine whether a particular type of child is allowed for the instance. It is called from appendChildElem(). The default is to allow no types (no children) Parameters:
  xslToken | The xsl token value of the child.
Returns: true if the child is allowed, or false if not. Reimplemented in ElemApplyTemplates, ElemAttribute, ElemAttributeSet, ElemCallTemplate, ElemChoose, ElemComment, ElemEmpty, ElemPI, and ElemText.

void ElemTemplateElement::childrenToResultAttribute ( | StylesheetExecutionContext & executionContext,
| const XalanDOMString & theName ) const

  | Take the contents of a template element, process it, and convert it to a string. Then, add an attribute to the result tree using the provided name and the string value. Parameters:
  executionContext | The current execution context
  theName | The name for the result attribute

void ElemTemplateElement::childrenToResultComment ( | StylesheetExecutionContext & executionContext ) const

  | Take the contents of a template element, process it, and convert it to a string. Then, add a comment to the result tree using the string value. Parameters:
  executionContext | The current execution context

void ElemTemplateElement::childrenToResultPI ( | StylesheetExecutionContext & executionContext,
| const XalanDOMString & theTarget ) const

  | Take the contents of a template element, process it, and convert it to a string. Then, add a processing instruction to the result tree using the string value, and the provided target. Parameters:
  executionContext | The current execution context
  theName | The name for the result attribute

const XalanDOMString & ElemTemplateElement::childrenToString ( | StylesheetExecutionContext & executionContext,
| XalanDOMString & result ) const

  | Take the contents of a template element, process it, and convert it to a string. Returns a const reference to the resulting string value. Note that this may _not_ be the XalanDOMString instance passed in, if an optimization is available to return a pre-existing string. Parameters:
  executionContext | The current execution context
  result | result of executing the elements children
Returns: a reference to a string containing the result.

ElemTemplateElement * ElemTemplateElement::cloneNode ( | bool deep ) const`[virtual]`

  | Returns a duplicate of this node. This function serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` returns `null`.). Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any text it contains unless it is a deep clone, since the text is contained in a child `Text` node. Cloning any other type of node simply returns a copy of this node. Parameters:
  deep | If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
Returns: The duplicate node. Reimplemented from XalanElement.

bool ElemTemplateElement::disableOutputEscaping ( | ) const`[protected]`

void ElemTemplateElement::disableOutputEscaping ( | bool value )`[protected]`

void ElemTemplateElement::execute ( | StylesheetExecutionContext & executionContext ) const`[virtual]`

  | Execute the element's primary function. Subclasses of this function may recursively execute down the element tree. Parameters:
  executionContext | The current execution context
Reimplemented in ElemApplyImport, ElemApplyTemplates, ElemAttribute, ElemAttributeSet, ElemCallTemplate, ElemChoose, ElemComment, ElemCopy, ElemCopyOf, ElemDecimalFormat, ElemElement, ElemEmpty, ElemExtensionCall, ElemFallback, ElemForEach, ElemIf, ElemLiteralResult, ElemMessage, ElemNumber, ElemOtherwise, ElemParam, ElemPI, ElemTemplate, ElemTextLiteral, ElemUse, ElemValueOf, ElemVariable, and ElemWhen.

void ElemTemplateElement::executeChildren ( | StylesheetExecutionContext & executionContext,
| XalanNode * sourceNode ) const`[virtual]`

  | Set the current node and process the children of a template. Parameters:
  processor | XSLT processor instance
  sourceNode | current node
Reimplemented in ElemTemplate.

void ElemTemplateElement::executeChildren ( | StylesheetExecutionContext & executionContext ) const`[virtual]`

  | Process the children of a template. Parameters:
  processor | XSLT processor instance
Reimplemented in ElemTemplate.

const XalanDOMString & ElemTemplateElement::getAttribute ( | const XalanDOMString & name ) const`[virtual]`

  | Retrieves an attribute value by name. Parameters:
  name | The name of the attribute to retrieve.
Returns: The `Attr` value as a string, or the empty string if that attribute does not have a specified or default value. Reimplemented from XalanElement.

const XalanDOMString & ElemTemplateElement::getAttributeNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & localName ) const`[virtual]`

  | Retrieves an attribute value by local name and namespace URI. Parameters:
  namespaceURI | The namespace URI of the attribute to retrieve.
  localName | The local name of the attribute to retrieve.
Returns: The `Attr` value as a string, or an empty string if that attribute does not have a specified or default value. Reimplemented from XalanElement.

XalanAttr * ElemTemplateElement::getAttributeNode ( | const XalanDOMString & name ) const`[virtual]`

  | Retrieves an `Attr` node by name. Parameters:
  name | The name (`nodeName`) of the attribute to retrieve.
Returns: The `Attr` node with the specified name (`nodeName`) or `null` if there is no such attribute. Reimplemented from XalanElement.

XalanAttr * ElemTemplateElement::getAttributeNodeNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & localName ) const`[virtual]`

  | Retrieves an `Attr` node by local name and namespace URI. Parameters:
  namespaceURI | The namespace URI of the attribute to retrieve.
  localName | The local name of the attribute to retrieve.
Returns: The `Attr` node with the specified attribute local name and namespace URI or `null` if there is no such attribute. Reimplemented from XalanElement.

const XalanNamedNodeMap * ElemTemplateElement::getAttributes ( | ) const`[virtual]`

| Gets a `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise. Reimplemented from XalanElement.

const XalanNodeList * ElemTemplateElement::getChildNodes ( | ) const`[virtual]`

| Gets a `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes. The content of the returned `NodeList` is "live" in the sense that, for instance, changes to the children of the node object that it was created from are immediately reflected in the nodes returned by the `NodeList` accessors; it is not a static snapshot of the content of the node. This is true for every `NodeList`, including the ones returned by the `getElementsByTagName` method. Reimplemented from XalanElement.

int ElemTemplateElement::getColumnNumber ( | ) const

| Get the column number in the stylesheet where the element appears. Returns: the column number in the stylesheet

const XalanDOMString & ElemTemplateElement::getElementName ( | ) const`[pure virtual]`

| Get a string for the name of the element. Useful for debugging purposes, and error reporting. Returns: A string containing the name of the element. Reimplemented in ElemApplyImport, ElemApplyTemplates, ElemAttribute, ElemAttributeSet, ElemCallTemplate, ElemChoose, ElemComment, ElemCopy, ElemCopyOf, ElemDecimalFormat, ElemElement, ElemEmpty, ElemFallback, ElemForEach, ElemIf, ElemLiteralResult, ElemMessage, ElemNumber, ElemOtherwise, ElemParam, ElemPI, ElemSort, ElemTemplate, ElemText, ElemTextLiteral, ElemUse, ElemValueOf, ElemVariable, ElemWhen, and ElemWithParam.

XalanNodeList * ElemTemplateElement::getElementsByTagName ( | const XalanDOMString & name ) const`[virtual]`

  | Returns a `NodeList` of all descendant elements with a given tag name, in the order in which they would be encountered in a preorder traversal of the `Element` tree. Caller is responsible for deleting the XalanNodeList instance. Parameters:
  name | The name of the tag to match on. The special value "*" matches all tags.
Returns: A list of matching `Element` nodes. Reimplemented from XalanElement.

XalanNodeList * ElemTemplateElement::getElementsByTagNameNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & localName ) const`[virtual]`

  | Returns a `NodeList` of all the `Element`s with a given local name and namespace URI in the order in which they would be encountered in a preorder traversal of the `Document` tree, starting from this node. Caller is responsible for deleting the XalanNodeList instance. Parameters:
  namespaceURI | The namespace URI of the elements to match on. The special value "*" matches all namespaces.
  localName | The local name of the elements to match on. The special value "*" matches all local names.
Returns: A new `NodeList` object containing all the matched `Element`s. Reimplemented from XalanElement.

bool ElemTemplateElement::getFinishedConstruction ( | ) const

| Get the flag indicating construction of the element is completed.

XalanNode * ElemTemplateElement::getFirstChild ( | ) const`[virtual]`

| Gets the first child of this node. If there is no such node, this returns `null`. Reimplemented from XalanElement.

ElemTemplateElement * ElemTemplateElement::getFirstChildElem ( | ) const`[virtual]`

| Get the first child. Returns: first child node of this node

IndexType ElemTemplateElement::getIndex ( | ) const`[virtual]`

| Get the node's index. Valid only if the owner document reports that the document is node-order indexed. Returns: The index value, or 0 if the node is not indexed. Reimplemented from XalanElement.

XalanNode * ElemTemplateElement::getLastChild ( | ) const`[virtual]`

| Gets the last child of this node. If there is no such node, this returns `null`. Reimplemented from XalanElement.

ElemTemplateElement * ElemTemplateElement::getLastChildElem ( | ) const`[virtual]`

| Get the last child. Returns: last child node of this node

int ElemTemplateElement::getLineNumber ( | ) const

| Get the line number in the stylesheet where the element appears. Returns: the line number in the stylesheet

const XalanDOMString & ElemTemplateElement::getLocalName ( | ) const`[virtual]`

| Returns the local part of the qualified name of this node. For nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, it is null. Reimplemented from XalanElement.

const LocatorType * ElemTemplateElement::getLocator ( | ) const`[virtual]`

| Get the Locator for the node. This may return 0. Returns: The Locator for the node.

const XalanQName & ElemTemplateElement::getNameAttribute ( | ) const`[virtual]`

| Get the QName associated with any name attribute of this element. If the element has no name attribute, this will be an empty QName. Returns: A string containing the name of the element. Reimplemented in ElemTemplate, and ElemVariable.

const XalanDOMString * ElemTemplateElement::getNamespaceForPrefix ( | const XalanDOMString & prefix ) const`[virtual]`

  | Retrieve a namespace corresponding to a prefix. This assumes that the PrevixResolver holds its own namespace context, or is a namespace context itself. Parameters:
  prefix | Prefix to resolve
Returns: namespace that prefix resolves to, or null if prefix is not found Reimplemented from PrefixResolver.

const XalanDOMString * ElemTemplateElement::getNamespaceForPrefixInternal ( | const XalanDOMString & prefix ) const`[protected]`

  | Get the namespace for a given prefix. Parameters:
  prefix | The prefix to search for
  fExists | If not null, set to true if the namespace was defined.
Returns: The namespace string.

const XalanDOMString & ElemTemplateElement::getNamespaceURI ( | ) const`[virtual]`

| Get the namespace URI of this node, or `null` if it is unspecified. This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time. For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`. Reimplemented from XalanElement.

const NamespacesHandler & ElemTemplateElement::getNamespaces ( | ) const`[protected]`

const NamespacesHandler & ElemTemplateElement::getNamespacesHandler ( | ) const

| Get the namespaces handler for this element. Returns: The element's NamespacesHandler instance.

XalanNode * ElemTemplateElement::getNextSibling ( | ) const`[virtual]`

| Gets the node immediately following this node. If there is no such node, this returns `null`. Reimplemented from XalanElement.

ElemTemplateElement * ElemTemplateElement::getNextSiblingElem ( | ) const`[virtual]`

| Get the next sibling. Returns: next sibling node of this node

const XalanDOMString & ElemTemplateElement::getNodeName ( | ) const`[virtual]`

| Reimplemented from XalanElement.

NodeType ElemTemplateElement::getNodeType ( | ) const`[virtual]`

| An enum value representing the type of the underlying object. Reimplemented from XalanElement.

const XalanDOMString & ElemTemplateElement::getNodeValue ( | ) const`[virtual]`

| Gets the value of this node, depending on its type. Reimplemented from XalanElement.

XalanDocument * ElemTemplateElement::getOwnerDocument ( | ) const`[virtual]`

| Gets the `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`. Reimplemented from XalanElement.

XalanNode * ElemTemplateElement::getParentNode ( | ) const`[virtual]`

| Gets the parent of this node. All nodes, except `Document`, `DocumentFragment`, and `Attr` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, a `null` Node is returned. Reimplemented from XalanElement.

ElemTemplateElement * ElemTemplateElement::getParentNodeElem ( | ) const`[virtual]`

| Get the parent node. Returns: parent node of this node

const XalanDOMString & ElemTemplateElement::getPrefix ( | ) const`[virtual]`

| Get the namespace prefix of this node, or `null` if it is unspecified. Reimplemented from XalanElement.

XalanNode * ElemTemplateElement::getPreviousSibling ( | ) const`[virtual]`

| Gets the node immediately preceding this node. If there is no such node, this returns `null`. Reimplemented from XalanElement.

ElemTemplateElement * ElemTemplateElement::getPreviousSiblingElem ( | ) const`[virtual]`

| Get the previous sibling. Returns: previous sibling node of this node

const Stylesheet & ElemTemplateElement::getStylesheet ( | ) const

| Retrieve the stylesheet from which this element comes. Returns: reference to source stylesheet

const XalanDOMString & ElemTemplateElement::getTagName ( | ) const`[virtual]`

| The name of the element. For example, in: <elementExample id="demo"> ... </elementExample> , `tagName` has the value `"elementExample"`. Note that this is case-preserving in XML, as are all of the operations of the DOM. Reimplemented from XalanElement.

const XalanDOMString & ElemTemplateElement::getURI ( | ) const`[virtual]`

| Retrieve the base URI for the resolver. Returns: URI string Reimplemented from PrefixResolver.

int ElemTemplateElement::getXSLToken ( | ) const

| Get an integer representation of the element type. Returns: integer representation of the element, defined in the Constants class See also: class Constants

bool ElemTemplateElement::hasChildNodes ( | ) const`[virtual]`

| This is a convenience method to allow easy determination of whether a node has any children. Returns: `true` if the node has any children, `false` if the node has no children. Reimplemented from XalanElement.

bool ElemTemplateElement::hasChildren ( | ) const

bool ElemTemplateElement::hasDirectTemplate ( | ) const

bool ElemTemplateElement::hasParams ( | ) const

bool ElemTemplateElement::hasPrefix ( | ) const`[protected]`

void ElemTemplateElement::hasPrefix ( | bool value )`[protected]`

bool ElemTemplateElement::hasSingleTextChild ( | ) const

bool ElemTemplateElement::hasVariables ( | ) const

XalanNode * ElemTemplateElement::insertBefore ( | XalanNode * newChild,
| XalanNode * refChild )`[virtual]`

  | Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children. If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed. Note that a `Node` that has never been assigned to refer to an actual node is == null. Parameters:
  newChild | The node to insert.
  refChild | The reference node, i.e., the node before which the new node must be inserted.
Returns: The node being inserted. Reimplemented from XalanElement.

bool ElemTemplateElement::isAttrOK ( | const XalanDOMChar * attrName,
| const AttributeListType & atts,
| int which,
| StylesheetConstructionContext & constructionContext ) const`[virtual]`

  | See if this is a xmlns attribute or in a non-XSLT. Parameters:
  attrName | qualified name of attribute
  atts | attribute list where the element comes from (not used at this time)
  which | index into the attribute list (not used at this time)
  constructionContext | The current construction context
Returns: true if this is a namespace name Reimplemented in ElemLiteralResult.

bool ElemTemplateElement::isDefaultTemplate ( | ) const

bool ElemTemplateElement::isIndexed ( | ) const`[virtual]`

| Determine if the document is node-order indexed. Returns: true if the document is indexed, otherwise false. Reimplemented from XalanElement.

bool ElemTemplateElement::isSupported ( | const XalanDOMString & feature,
| const XalanDOMString & version ) const`[virtual]`

  | Tests whether the DOM implementation implements a specific feature and that feature is supported by this node. Parameters:
  feature | The string of the feature to test. This is the same name as what can be passed to the method `hasFeature` on `DOMImplementation`.
  version | This is the version number of the feature to test. In Level 2, version 1, this is the string "2.0". If the version is not specified, supporting any version of the feature will cause the method to return `true`.
Returns: Returns `true` if the specified feature is supported on this node, `false` otherwise. Reimplemented from XalanElement.

bool ElemTemplateElement::isValidNCName ( | const XalanDOMString & s )`[static]`

  | Validate that the string is an NCName. Parameters:
  s | name in question
Returns: true if the string is a valid NCName according to XML rules See also: http://www.w3.org/TR/REC-xml-names#NT-NCName

bool ElemTemplateElement::isWhitespace ( | ) const`[virtual]`

| Tell if the element will generate text which is XML whitespace. Returns: true if the text is pure whitespace Reimplemented in ElemTextLiteral.

void ElemTemplateElement::namespacesPostConstruction ( | StylesheetConstructionContext & constructionContext,
| const NamespacesHandler & theParentHandler,
| NamespacesHandler & theHandler )`[protected, virtual]`

| Called after construction is completed. This is a hook for deriving classes to handle post-construction with the instances HamespaceHandler instance, which is otherwise only available through a const accessor. Reimplemented in ElemElement, and ElemLiteralResult.

void ElemTemplateElement::normalize ( | )`[virtual]`

| Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only markup (e.g., tags, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are no adjacent `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer lookups) that depend on a particular document tree structure are to be used. Note: In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes. Reimplemented from XalanElement.

void ElemTemplateElement::postConstruction ( | StylesheetConstructionContext & constructionContext,
| const NamespacesHandler & theParentHandler )`[virtual]`

| Called after construction is completed. Reimplemented in ElemCallTemplate, ElemForEach, ElemLiteralResult, and ElemUse.

bool ElemTemplateElement::preserveSpace ( | ) const`[protected]`

void ElemTemplateElement::preserveSpace ( | bool value )`[protected]`

bool ElemTemplateElement::processPrefixControl ( | StylesheetConstructionContext & constructionContext,
| const Stylesheet & stylesheetTree,
| const XalanDOMString & localName,
| const XalanDOMChar * attrValue )`[protected]`

  | Process the exclude-result-prefixes or the extension-element-prefixes attributes, for the purpose of prefix exclusion. Parameters:
  constructionContext | context when object consructed
  stylesheetTree | The current Stylesheet object.
  localName | The local name of the attribute.
  attrValue | The value of the attribute.

void ElemTemplateElement::processSortElement ( | StylesheetConstructionContext & constructionContext,
| Stylesheet & theStylesheet,
| const AttributeListType & atts,
| const LocatorType * locator = 0 )`[virtual]`

  | Called during compilation to process xsl:sort elements in the stylesheet. Parameters:
  constructionContext | The current construction context
  theStylesheet | The owning stylesheet
  atts | The list of attributes for the sort element
  locator | A Locator instance for error reporting, if available.
Returns: nothing Reimplemented in ElemForEach.

bool ElemTemplateElement::processSpaceAttr ( | const XalanDOMChar * aname,
| const AttributeListType & atts,
| int which,
| StylesheetConstructionContext & constructionContext )

  | Tell whether or not this is a xml:space attribute and, if so, process it. Parameters:
  aname | name of the attribute in question
  atts | attribute list that owns the attribute
  which | index of the attribute into the attribute list
  constructionContext | The current construction context
Returns: true if this is a xml:space attribute

void ElemTemplateElement::removeAttribute ( | const XalanDOMString & name )`[virtual]`

  | Removes an attribute by name. If the removed attribute is known to have a default value, an attribute immediately appears containing the default value as well as the corresponding namespace URI, local name, and prefix when applicable. To remove an attribute by local name and namespace URI, use the `removeAttributeNS` method. Parameters:
  name | The name of the attribute to remove.
  Exceptions:
  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
Reimplemented from XalanElement.

void ElemTemplateElement::removeAttributeNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & localName )`[virtual]`

  | Removes an attribute by local name and namespace URI. If the removed attribute has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix. HTML-only DOM implementations do not need to implement this method. Parameters:
  namespaceURI | The namespace URI of the attribute to remove.
  localName | The local name of the attribute to remove.
  Exceptions:
  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
Reimplemented from XalanElement.

XalanAttr * ElemTemplateElement::removeAttributeNode ( | XalanAttr * oldAttr )`[virtual]`

  | Removes the specified attribute node. If the removed `Attr` has a default value it is immediately replaced. The replacing attribute has the same namespace URI and local name, as well as the original prefix, when applicable. Parameters:
  oldAttr | The `Attr` node to remove from the attribute list.
  Returns: The `Attr` node that was removed. Exceptions:
  DOMException | NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NOT_FOUND_ERR: Raised if `oldAttr` is not an attribute of the element.
Reimplemented from XalanElement.

XalanNode * ElemTemplateElement::removeChild ( | XalanNode * oldChild )`[virtual]`

  | Removes the child node indicated by `oldChild` from the list of children, and returns it. Parameters:
  oldChild | The node being removed.
Returns: The node removed. Reimplemented from XalanElement.

XalanNode * ElemTemplateElement::replaceChild ( | XalanNode * newChild,
| XalanNode * oldChild )`[virtual]`

  | Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node. If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order. If the `newChild` is already in the tree, it is first removed. Parameters:
  newChild | The new node to put in the child list.
  oldChild | The node being replaced in the list.
Returns: The node replaced. Reimplemented from XalanElement.

void ElemTemplateElement::setAttribute ( | const XalanDOMString & name,
| const XalanDOMString & value )`[virtual]`

  | Adds a new attribute. If an attribute with that name is already present in the element, its value is changed to be that of the value parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create an `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNode` to assign it as the value of an attribute. Parameters:
  name | The name of the attribute to create or alter.
  value | Value to set in string form.
  Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified name contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
Reimplemented from XalanElement.

void ElemTemplateElement::setAttributeNS ( | const XalanDOMString & namespaceURI,
| const XalanDOMString & qualifiedName,
| const XalanDOMString & value )`[virtual]`

  | Adds a new attribute. If the given `namespaceURI` is `null` or an empty string and the `qualifiedName` has a prefix that is "xml", the new attribute is bound to the predefined namespace "http://www.w3.org/XML/1998/namespace". If an attribute with the same local name and namespace URI is already present on the element, its prefix is changed to be the prefix part of the `qualifiedName`, and its value is changed to be the `value` parameter. This value is a simple string, it is not parsed as it is being set. So any markup (such as syntax to be recognized as an entity reference) is treated as literal text, and needs to be appropriately escaped by the implementation when it is written out. In order to assign an attribute value that contains entity references, the user must create a `Attr` node plus any `Text` and `EntityReference` nodes, build the appropriate subtree, and use `setAttributeNodeNS` or `setAttributeNode` to assign it as the value of an attribute. Parameters:
  namespaceURI | The namespace URI of the attribute to create or alter.
  localName | The local name of the attribute to create or alter.
  value | The value to set in string form.
  Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified qualified name contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NAMESPACE_ERR: Raised if the `qualifiedName` is malformed, if the `qualifiedName` has a prefix that is "xml" and the `namespaceURI` is neither `null` nor an empty string nor "http://www.w3.org/XML/1998/namespace", or if the `qualifiedName` has a prefix that is "xmlns" but the `namespaceURI` is neither `null` nor an empty string, or if if the `qualifiedName` has a prefix different from "xml" and "xmlns" and the `namespaceURI` is `null` or an empty string.
Reimplemented from XalanElement.

XalanAttr * ElemTemplateElement::setAttributeNode ( | XalanAttr * newAttr )`[virtual]`

  | Adds a new attribute. If an attribute with that name (`nodeName`) is already present in the element, it is replaced by the new one. Parameters:
  newAttr | The `Attr` node to add to the attribute list.
  Returns: If the `newAttr` attribute replaces an existing attribute, the replaced `Attr` node is returned, otherwise `null` is returned. Exceptions:
  DOMException | WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.
Reimplemented from XalanElement.

XalanAttr * ElemTemplateElement::setAttributeNodeNS ( | XalanAttr * newAttr )`[virtual]`

  | Adds a new attribute. If an attribute with that local name and namespace URI is already present in the element, it is replaced by the new one. Parameters:
  newAttr | The `Attr` node to add to the attribute list.
  Returns: If the `newAttr` attribute replaces an existing attribute with the same local name and namespace URI, the replaced `Attr` node is returned, otherwise `null` is returned. Exceptions:
  DOMException | WRONG_DOCUMENT_ERR: Raised if `newAttr` was created from a different document than the one that created the element. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. INUSE_ATTRIBUTE_ERR: Raised if `newAttr` is already an attribute of another `Element` object. The DOM user must explicitly clone `Attr` nodes to re-use them in other elements.
Reimplemented from XalanElement.

void ElemTemplateElement::setDefaultTemplate ( | bool value )`[virtual]`

  | Sets a flag indicating this is the default template. Parameters:
  value | The value of flag.

void ElemTemplateElement::setFinishedConstruction ( | bool fValue )

  | Set the flag indicating construction of the element is completed. Parameters:
  fValue | The value to set

void ElemTemplateElement::setFirstChildElem ( | ElemTemplateElement * theChild )`[virtual]`

| Set the first child. theChild - the new value for the first child. Returns: nothing

void ElemTemplateElement::setNextSiblingElem ( | ElemTemplateElement * theSibling )`[virtual]`

| Set the next sibling. theSibling - the new value for the next sibling. Returns: nothing

void ElemTemplateElement::setNodeValue ( | const XalanDOMString & nodeValue )`[virtual]`

| Sets the value of the node. Any node which can have a nodeValue ( See also: getNodeValue) will also accept requests to set it to a string. The exact response to this varies from node to node -- Attribute, for example, stores its values in its children and has to replace them with a new Text holding the replacement value. For most types of Node, value is null and attempting to set it will throw DOMException(NO_MODIFICATION_ALLOWED_ERR). This will also be thrown if the node is read-only. Reimplemented from XalanElement.

void ElemTemplateElement::setParentNodeElem ( | ElemTemplateElement * theParent )`[virtual]`

| Set the parent node. theParent - the new value for the parent. Returns: nothing Reimplemented in ElemVariable.

void ElemTemplateElement::setPrefix ( | const XalanDOMString & prefix )`[virtual]`

  | Set the namespace prefix of this node. Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable. Note also that changing the prefix of an attribute, that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change. Parameters:
  prefix | The prefix of this node.
  Exceptions:
  DOMException | INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character. NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly. NAMESPACE_ERR: Raised if the specified `prefix` is malformed, if the specified prefix is "xml" and the `namespaceURI` of this node is different from "http://www.w3.org/XML/1998/namespace", if specified prefix is "xmlns" and the `namespaceURI` is neither `null` nor an empty string, or if the `localName` is `null`.
Reimplemented from XalanElement.

void ElemTemplateElement::setPreviousSiblingElem ( | ElemTemplateElement * theSibling )`[virtual]`

| Set the previous sibling. theSibling - the new value for the previous sibling. Returns: nothing

void ElemTemplateElement::transformChild ( | StylesheetExecutionContext & executionContext,
| const ElemTemplateElement & xslInstruction,
| const ElemTemplateElement * theTemplate,
| XalanNode * child,
| XalanNode::NodeType nodeType ) const`[protected, virtual]`

  | Given an element, find the corresponding template and process the contents. Parameters:
  executionContext | The current execution context
  xslInstruction | The calling element
  template | The template to use if xsl:for-each, or null.
  child | The source context node.
  nodeType | The type of child.

void ElemTemplateElement::transformChild ( | StylesheetExecutionContext & executionContext,
| const ElemTemplateElement & xslInstruction,
| const ElemTemplateElement * theTemplate,
| XalanNode * child ) const`[protected, virtual]`

  | Given an element, find the corresponding template and process the contents. Parameters:
  executionContext | The current execution context
  xslInstruction | The calling element
  template | The template to use if xsl:for-each, or null.
  child | The source context node.
Reimplemented in ElemApplyTemplates.

## Member Data Documentation

const ElemTemplate* ElemTemplateElement::m_directTemplate

ElemTemplateElement* ElemTemplateElement::m_firstChild

const ElemTextLiteral* ElemTemplateElement::m_textLiteralChild

const XalanDOMString ElemTemplateElement::s_emptyString`[static, protected]`

The documentation for this class was generated from the following file:

- ElemTemplateElement.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.5 Copyright © 2000, 2001, 2002, 2003 The Apache Software Foundation. All Rights Reserved.